--AH:ScriptId=6bcbce7c-f5d4-418c-9a4f-c4beabc3ac66;394
ALTER TABLE [PlanActions]
  DROP CONSTRAINT [PK__PlanActions]
  
UPDATE [PlanActions]
   SET [Action_Sequence] = (SELECT [Rank] FROM
                            (SELECT [Plan_Id], [Action_Sequence], [Rank] = RANK() OVER 
                                    (PARTITION BY [Plan_Id]
		                             ORDER BY [Plan_Id], [Action_Sequence])
		                     FROM [PlanActions]) PA_RANKED
		                    WHERE PA_RANKED.[Plan_Id] = PA.[Plan_Id]
		                      AND PA_RANKED.[Action_Sequence] = PA.[Action_Sequence])
  FROM [PlanActions] PA
		                             
ALTER TABLE [PlanActions]
  ADD CONSTRAINT [PK__PlanActions] PRIMARY KEY ([Plan_Id], [Action_Sequence])
GO

CREATE TRIGGER [TR__PlanActions__ValidateSequence]
       ON [PlanActions] FOR UPDATE, INSERT, DELETE
AS 
BEGIN

	IF EXISTS(
			SELECT *
			  FROM [PlanActions] PA
				   INNER JOIN (SELECT [Plan_Id], [Action_Sequence],
									  [Actual_Action_Sequence] = 
										   ROW_NUMBER() OVER (PARTITION BY [Plan_Id]
										   ORDER BY [Plan_Id], [Action_Sequence])
									  FROM [PlanActions]) PA_ACTUAL
						   ON PA.[Plan_Id] = PA_ACTUAL.[Plan_Id]
						  AND PA.[Action_Sequence] = PA_ACTUAL.[Action_Sequence]
			 WHERE PA.[Action_Sequence] <> PA_ACTUAL.[Actual_Action_Sequence]
			   AND ( 
			         EXISTS ( SELECT * FROM inserted
			                   WHERE PA.[Plan_Id] = [Plan_Id])
					 OR 
			         EXISTS ( SELECT * FROM deleted
			                   WHERE PA.[Plan_Id] = [Plan_Id])
				   )
		) 
	BEGIN

		RAISERROR('An invalid PlanAction_Sequence was provided for the PlanAction.', 16, 1)
		ROLLBACK
	
	END
		
END
GO