--AH:ScriptId=9f1931df-6258-47d3-be61-df4eb0368851;700
DECLARE @LocalServer INT
SET @LocalServer = (SELECT TOP 1 [Server_Id]
                      FROM [Servers]
                     WHERE [Agent_Configuration].value('local-name((/*)[1])', 'varchar(200)') = 'Inedo.BuildMaster.Extensibility.Agents.Local.LocalAgent'
                       AND [Agent_Configuration].value('(/*/@Assembly)[1]', 'varchar(200)') = 'BuildMasterExtensions'
                     ORDER BY [Server_Id])

DECLARE @SetToNullServer TABLE
(
	[Plan_Id] INT NOT NULL,
	[Action_Sequence] INT NOT NULL
)

DECLARE @SetToLocalServer TABLE
(
	[Plan_Id] INT NOT NULL,
	[Action_Sequence] INT NOT NULL
)

INSERT INTO @SetToNullServer
(
	[Plan_Id],
	[Action_Sequence]
)
SELECT PA.[Plan_Id],
       PA.[Action_Sequence]
  FROM [PlanActions] PA
 WHERE PA.[Server_Id] = @LocalServer
   AND EXISTS(SELECT *
                FROM [PlanActionGroups] PAG
               WHERE PAG.[ActionGroup_Id] = PA.[Plan_Id]
                 AND (PAG.[Server_Id] IS NOT NULL OR PAG.[Server_Variable_Name] IS NOT NULL))

INSERT INTO @SetToLocalServer
(
	[Plan_Id],
	[Action_Sequence]
)
SELECT [Plan_Id],
       [Action_Sequence]
  FROM [PlanActions]
 WHERE [Server_Id] IS NULL
   AND [Server_Variable_Name] IS NULL

-- If a group is shared and has a default server in one instance but not another,
-- set the non-defaulted one to server id 1
UPDATE [PlanActionGroups]
   SET [Server_Id] = @LocalServer
 WHERE [Server_Id] IS NULL
   AND [Server_Variable_Name] IS NULL
   AND [ActionGroup_Id] IN (SELECT [Plan_Id] FROM @SetToNullServer)


-- Set all inherited actions to have a null server
UPDATE PA
   SET PA.[Server_Id] = NULL,
       PA.[Server_Variable_Name] = NULL
  FROM @SetToNullServer NS
       INNER JOIN [PlanActions] PA
               ON PA.[Plan_Id] = NS.[Plan_Id]
              AND PA.[Action_Sequence] = NS.[Action_Sequence]

-- Set all non-remote actions to the local server
UPDATE PA
   SET PA.[Server_Id] = @LocalServer
  FROM @SetToLocalServer LS
       INNER JOIN [PlanActions] PA
               ON PA.[Plan_Id] = LS.[Plan_Id]
              AND PA.[Action_Sequence] = LS.[Action_Sequence]