IF OBJECT_ID('[ActionGroupActions_Extended]') IS NOT NULL DROP VIEW [ActionGroupActions_Extended]
GO

CREATE VIEW [ActionGroupActions_Extended] AS

    SELECT AGA.[ActionGroup_Id],
           AGA.[Action_Sequence],
           AGA.[Server_Id],
           AGA.[Long_Description],
           AGA.[ResumeNextOnFailure_Indicator],
           AGA.[Action_Configuration],
           AGA.[Short_Description],
           AGA.[Active_Indicator],
           AGA.[Retry_Count],
           AGA.[LogFailureAsWarning_Indicator],
	       AGA.[Server_Variable_Name],
	       AGA.[Target_Server_Id],
	       AGA.[Target_Server_Variable_Name],
	       AGA.[ExtensionConfiguration_Id],
           [Configuration_Profile_Name] = E.[Profile_Name],
           SRC_S.[Server_Name],
           [Target_Server_Name] = TRG_S.[Server_Name],
           SRC_S.[ServerType_Code],
           [Target_ServerType_Code] = TRG_S.[ServerType_Code]

      FROM [ActionGroupActions] AGA
INNER JOIN [ActionGroups] AG
        ON AG.[ActionGroup_Id] = AGA.[ActionGroup_Id]
 LEFT JOIN [ExtensionConfigurations] E
        ON E.[ExtensionConfiguration_Id] = AGA.[ExtensionConfiguration_Id]
 LEFT JOIN [Servers] SRC_S
        ON SRC_S.[Server_Id] = AGA.[Server_Id]
 LEFT JOIN [Servers] TRG_S
        ON TRG_S.[Server_Id] = AGA.[Target_Server_Id]

GO
