IF OBJECT_ID('[BuildPromotions_Extended]') IS NOT NULL DROP VIEW [BuildPromotions_Extended]
GO

CREATE VIEW [BuildPromotions_Extended] AS

SELECT A.[Application_Id]
      ,R.[Release_Id]
      ,R.[Release_Number]
	  ,B.[Build_Id]
      ,B.[Build_Number]
	  ,BP.[Promotion_Id]
      ,BP.[Promoted_Date]
      ,BP.[PromotedBy_Name]
      ,BP.[Comments_Text]
      ,BP.[PromotionStatus_Name]
	  ,BP.[StatusOverriddenBy_User_Name]
	  ,BP.[StatusOverriddenReason_Text]
	  ,BP.[StatusOverridden_Date]
	  ,BP.[Forced_Indicator]

      ,A.[Application_Name]

      ,B.[BuildStatus_Name]

      ,R.[Pipeline_Id]
      ,R.[Release_Sequence]

	  ,BE.[Execution_Id] AS [Last_Execution_Id]
	  ,X.[Start_Date] AS [Last_ExecutionStart_Date]
	  ,[Last_ExecutionStatus_Name] =
		   CASE
				WHEN X.[ExecutionRunState_Code] = 'P' THEN 'Pending'
				WHEN X.[ExecutionRunState_Code] = 'X' AND X.[CanceledOn_Date] IS NULL THEN 'Executing'
				WHEN X.[ExecutionRunState_Code] = 'X' AND X.[CanceledOn_Date] IS NOT NULL THEN 'Canceled'
				WHEN X.[ExecutionStatus_Code] = 'E' THEN 'Failed'
				ELSE 'Succeeded'
		   END

      ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])
	  ,BP.[PipelineStage_Name]

  FROM [BuildPromotions] BP
       INNER JOIN [Builds] B
               ON B.[Build_Id] = BP.[Build_Id]
       INNER JOIN [Releases] R
               ON R.[Release_Id] = B.[Release_Id]
       INNER JOIN [Applications] A
               ON A.[Application_Id] = R.[Application_Id]
	   LEFT JOIN [BuildExecutions] BE
	          ON BE.[Execution_Id] = 
	             (
	              SELECT TOP 1 _BE.[Execution_Id]
	                FROM [BuildExecutions] _BE
					     INNER JOIN [Executions] _X
						         ON _X.[Execution_Id] = _BE.[Execution_Id]
	               WHERE _BE.[Promotion_Id] = BP.[Promotion_Id]
	               ORDER BY _X.[Execution_Id] DESC
	             )
		LEFT JOIN [Executions] X
		       ON X.[Execution_Id] = BE.[Execution_Id]
GO
