IF OBJECT_ID('[Calendars_ReleaseTargetDates]') IS NOT NULL DROP VIEW [Calendars_ReleaseTargetDates]
GO

CREATE VIEW [Calendars_ReleaseTargetDates]
AS

	SELECT
        RTD.[Target_Name]
       ,RTD.[Start_Date]
       ,RTD.[End_Date]

       ,R.[Release_Id]
       ,[Release_Name] = COALESCE(R.[Release_Name], R.[Release_Number])
       
       ,A.[Application_Id]
       ,A.[Application_Name]

       ,P.[Pipeline_Name]
       
    FROM [ReleaseTargetDates] RTD

    INNER JOIN [Releases] R
            ON R.[Release_Id] = RTD.[Release_Id]
    INNER JOIN [Applications] A
            ON A.[Application_Id] = R.[Application_Id]
     LEFT JOIN [Pipelines] P
            ON P.[Pipeline_Id] = R.[Pipeline_Id]


GO
