EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Applications_GetNavigationData',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataSet',
    /* DataTableNames_Csv      */ 'Applications_Extended,Builds_Extended,ApplicationDeploymentPlans',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the information required to display the application navigation bar.'
GO


IF OBJECT_ID('[Applications_GetNavigationData]') IS NOT NULL DROP PROCEDURE [Applications_GetNavigationData]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Applications_GetNavigationData]
(
    @Application_Id INT
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [Applications_Extended]
	 WHERE [Application_Id] = @Application_Id

	SELECT *
	  FROM [Builds_Extended]
	 WHERE [Application_Id] = @Application_Id
	   AND [BuildStatus_Name] = 'Active'
	 ORDER BY [CreatedOn_Date] DESC

	SELECT *
	  FROM [ApplicationDeploymentPlans]
	 WHERE [Application_Id] = @Application_Id

END
GO

GRANT EXECUTE ON [Applications_GetNavigationData] TO [BuildMasterUser_Role]
