EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'BuildTestResults_GetTestGroupResultsForBuild',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'BuildTestResults_TestGroupResults',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the unit test results for the specified build.'
GO


IF OBJECT_ID('[BuildTestResults_GetTestGroupResultsForBuild]') IS NOT NULL DROP PROCEDURE [BuildTestResults_GetTestGroupResultsForBuild]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [BuildTestResults_GetTestGroupResultsForBuild]
(
	@Application_Id INT,
    @Release_Number RELEASENUMBER,
    @Build_Number BUILDNUMBER
)
AS
BEGIN

	SET NOCOUNT ON

    DECLARE @Max_Execution_Id INT

    SELECT TOP 1 @Max_Execution_Id = [Execution_Id]
      FROM [BuildTestResults_TestGroupResults] TGR
	       INNER JOIN [Builds] B
		           ON B.[Build_Id] = TGR.Build_Id
		   INNER JOIN [Releases] R
		           ON R.[Release_Id] = B.[Release_Id]
	 WHERE R.[Application_Id] = @Application_Id
       AND R.[Release_Number] = @Release_Number
       AND B.[Build_Number] = @Build_Number
     ORDER BY [Execution_Id] DESC

    SELECT *
      FROM [BuildTestResults_TestGroupResults]
	 WHERE [Execution_Id] = @Max_Execution_Id

END
GO

GRANT EXECUTE ON [BuildTestResults_GetTestGroupResultsForBuild] TO [BuildMasterUser_Role]