EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ConfigurationFiles_GetConfigurationFileVersions',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ConfigurationFileVersions_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of configuration file versions for a specified configuration file.'
GO

IF OBJECT_ID('[ConfigurationFiles_GetConfigurationFileVersions]') IS NOT NULL DROP PROCEDURE [ConfigurationFiles_GetConfigurationFileVersions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ConfigurationFiles_GetConfigurationFileVersions]
(
	@ConfigurationFile_Id INT,
	@Instance_Name VARCHAR(100) = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [ConfigurationFileVersions_Extended]
	 WHERE [ConfigurationFile_Id] = @ConfigurationFile_Id
	   AND @Instance_Name IS NULL OR ([Instance_Name] = @Instance_Name)

END
GO

GRANT EXECUTE ON [ConfigurationFiles_GetConfigurationFileVersions] TO [BuildMasterUser_Role]
