EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'LegacyExecutions_GetExecutionLogForActions',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'BuildExecution_ActionGroupActionLogEntries',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets all of the log entries for the actions specified.'
GO

IF OBJECT_ID('[LegacyExecutions_GetExecutionLogForActions]') IS NOT NULL DROP PROCEDURE [LegacyExecutions_GetExecutionLogForActions]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [LegacyExecutions_GetExecutionLogForActions]
(
	@BuildExecution_ActionGroupActions_Csv VARCHAR(MAX)
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT BEAGALE.*
	  FROM dbo.CsvToTable(@BuildExecution_ActionGroupActions_Csv, ',') T
	       INNER JOIN [BuildExecution_ActionGroupActionLogEntries] BEAGALE
	               ON BEAGALE.[BuildExecution_ActionGroupAction_Id] = T.[Value_Text]

END
GO

GRANT EXECUTE ON [LegacyExecutions_GetExecutionLogForActions] TO [BuildMasterUser_Role]
