EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_DeletePlan',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes an OtterScript plan.'
GO


IF OBJECT_ID('[Plans_DeletePlan]') IS NOT NULL DROP PROCEDURE [Plans_DeletePlan]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_DeletePlan]
(
	@Plan_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

 	--DELETE [Plans] WHERE [Plan_Id] = @Plan_Id
    UPDATE [Plans]
       SET [Active_Indicator] = 'N'
     WHERE [Plan_Id] = @Plan_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Plans_DeletePlan] TO [BuildMasterUser_Role]
