EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Plans_GetPlanVersion',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataRow',
    /* DataTableNames_Csv      */ 'PlanVersions',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Returns a specific version of the specified OtterScript plan.'
GO


IF OBJECT_ID('[Plans_GetPlanVersion]') IS NOT NULL DROP PROCEDURE [Plans_GetPlanVersion]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Plans_GetPlanVersion]
(
	@Plan_Id INT,
    @PlanVersion_Id INT
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT *
	  FROM [PlanVersions]
     WHERE [Plan_Id] = @Plan_Id
       AND [PlanVersion_Id] = @PlanVersion_Id

END
GO

GRANT EXECUTE ON [Plans_GetPlanVersion] TO [BuildMasterUser_Role]