EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'RetentionPolicies_EndPurge',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Marks the end of a purge.'
GO


IF OBJECT_ID('[RetentionPolicies_EndPurge]') IS NOT NULL DROP PROCEDURE [RetentionPolicies_EndPurge]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [RetentionPolicies_EndPurge]
(
	@RetentionPoliciesPurgeHistoryEntry_Id INT,
	@LogText_Bytes VARBINARY(MAX)
)
AS
BEGIN

	SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

    IF (@LogText_Bytes <> 0x)
    BEGIN

	    UPDATE [RetentionPoliciesPurgeHistory]
	       SET [End_Date] = GETUTCDATE(),
	           [LogText_Bytes] = @LogText_Bytes
	     WHERE [RetentionPoliciesPurgeHistoryEntry_Id] = @RetentionPoliciesPurgeHistoryEntry_Id

    END
    ELSE
    BEGIN

        DELETE [RetentionPoliciesPurgeHistory]
         WHERE [RetentionPoliciesPurgeHistoryEntry_Id] = @RetentionPoliciesPurgeHistoryEntry_Id

    END

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [RetentionPolicies_EndPurge] TO [BuildMasterUser_Role]