EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ServerRoles_CreateOrUpdateServerRole',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'ServerRole_Id',
    /* Description_Text        */ 'Creates or updates a server role.'
GO


IF OBJECT_ID('[ServerRoles_CreateOrUpdateServerRole]') IS NOT NULL DROP PROCEDURE [ServerRoles_CreateOrUpdateServerRole]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ServerRoles_CreateOrUpdateServerRole]
(
	@ServerRole_Name NVARCHAR(50),
    @ServerIds_Csv VARCHAR(MAX) = NULL,
    @ServerRole_Id INT = NULL OUT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	IF (@ServerRole_Id IS NULL)
	BEGIN

		INSERT INTO [ServerRoles] ([ServerRole_Name])
		VALUES (@ServerRole_Name)

		SET @ServerRole_Id = SCOPE_IDENTITY()

	END ELSE BEGIN

		UPDATE [ServerRoles]
		   SET [ServerRole_Name] = @ServerRole_Name
		 WHERE [ServerRole_Id] = @ServerRole_Id

	END

    IF @ServerIds_Csv IS NOT NULL
    BEGIN

        DELETE [ServerRoleServers] 
         WHERE [ServerRole_Id] = @ServerRole_Id

        INSERT [ServerRoleServers] ([Server_Id], [ServerRole_Id])
        SELECT CAST([Value_Text] AS INT), @ServerRole_Id 
          FROM dbo.CsvToTable(@ServerIds_Csv, ',')

    END

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [ServerRoles_CreateOrUpdateServerRole] TO [BuildMasterUser_Role]
